diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-mui/repodlgs.c freeciv-patched/client/gui-mui/repodlgs.c
--- freeciv-cvs/client/gui-mui/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-mui/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -702,7 +702,7 @@
     my_snprintf(building_count, sizeof(building_count), "%5d", entry->building_count);
 
     *array++ = unit_name(i);
-    *array++ = can_upgrade_unittype(game.player_ptr, i) != -1 ? "*" : "-";
+    *array++ = can_upgrade_unittype(game.player_ptr, i, TRUE) != -1 ? "*" : "-";
     *array++ = building_count;
     *array++ = active_count;
     *array++ = upkeep_shield;
@@ -729,7 +729,7 @@
   DoMethod(actunit_units_listview, MUIM_NList_GetEntry, *newval, &entry);
   if (entry)
   {
-    if (can_upgrade_unittype(game.player_ptr, entry->type) != -1)
+    if (can_upgrade_unittype(game.player_ptr, entry->type, TRUE) != -1)
       set(actunit_upgrade_button, MUIA_Disabled, FALSE);
     else
       set(actunit_upgrade_button, MUIA_Disabled, TRUE);
@@ -758,7 +758,7 @@
     int ut1, ut2;
 
     ut1 = entry->type;
-    ut2 = can_upgrade_unittype(game.player_ptr, entry->type);
+    ut2 = can_upgrade_unittype(game.player_ptr, entry->type, TRUE);
 
     if (ut2 != -1)
     {
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-sdl/repodlgs.c freeciv-patched/client/gui-sdl/repodlgs.c
--- freeciv-cvs/client/gui-sdl/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-sdl/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -191,7 +191,7 @@
   
   pUnits_Upg_Dlg = MALLOC(sizeof(struct SMALL_DLG));
 
-  ut2 = can_upgrade_unittype(game.player_ptr, ut1);
+  ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
   value = unit_upgrade_price(game.player_ptr, ut1, ut2);
   
   my_snprintf(cBuf, sizeof(cBuf),
@@ -450,7 +450,7 @@
   count = 0; 
   unit_type_iterate(i) {
     if ((units[i].active_count > 0) || (units[i].building_count > 0)) {
-      upgrade = (can_upgrade_unittype(game.player_ptr, i) != -1);
+      upgrade = (can_upgrade_unittype(game.player_ptr, i, TRUE) != -1);
       pUnit = get_unit_type(i);
 	
       /* ----------- */
@@ -841,7 +841,7 @@
       pBuf = pWidget;
       if ((units[i].active_count > 0) || (units[i].building_count > 0)) {
         if (i == MAX_ID - pBuf->ID) {
-UPD:	  upgrade = (can_upgrade_unittype(game.player_ptr, i) != -1);
+UPD:	  upgrade = (can_upgrade_unittype(game.player_ptr, i, TRUE) != -1);
 	  pBuf = pBuf->prev;
 	  if(upgrade) {
 	    pBuf->string16->forecol = sellect;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-win32/citydlg.c freeciv-patched/client/gui-win32/citydlg.c
--- freeciv-cvs/client/gui-win32/citydlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-win32/citydlg.c	2003-06-30 12:16:42.000000000 +0100
@@ -1559,7 +1559,7 @@
     ut1=punit->type;
     /* printf("upgrade_callback for %s\n", unit_types[ut1].name); */
  
-    ut2=can_upgrade_unittype(game.player_ptr,ut1);
+    ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
  
     if (ut2==-1) {
       /* this shouldn't generally happen, but it is conceivable */
@@ -1669,7 +1669,7 @@
      if (punit->homecity == pcity->id) {
        message_dialog_button_set_sensitive(wd,5, FALSE);
      }
-     if (can_upgrade_unittype(game.player_ptr,punit->type) == -1) {
+     if (can_upgrade_unittype(game.player_ptr, punit->type, TRUE) == -1) {
        message_dialog_button_set_sensitive(wd,6, FALSE);
      }        
    }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-win32/gotodlg.c freeciv-patched/client/gui-win32/gotodlg.c
--- freeciv-cvs/client/gui-win32/gotodlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-win32/gotodlg.c	2003-06-30 12:16:19.000000000 +0100
@@ -189,7 +189,7 @@
     if(!show_all_cities && i!=game.player_idx) continue;
     city_list_iterate(game.players[i].cities, pcity) {
       sz_strlcpy(name, pcity->name);
-      if (pcity->improvements[B_AIRPORT] == I_ACTIVE)
+      if (pcity->airlift)
         sz_strlcat(name, "(A)");
       j=ListBox_AddString(list,name);
       ListBox_SetItemData(list,j,pcity->id);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-win32/repodlgs.c freeciv-patched/client/gui-win32/repodlgs.c
--- freeciv-cvs/client/gui-win32/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-win32/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -544,7 +544,7 @@
       if (sel>=0) {
 	if ((unit_type_exists(activeunits_type[sel])) &&
 	    (can_upgrade_unittype(game.player_ptr,
-				  activeunits_type[sel]) != -1))    
+				  activeunits_type[sel], TRUE) != -1))    
 	  EnableWindow(GetDlgItem(activeunits_dlg,ID_MILITARY_UPGRADE),
 		       TRUE);
 	else
@@ -570,7 +570,8 @@
 	      ut1 = activeunits_type[sel];
 	      if (!(unit_type_exists (ut1)))
 		break;
-	      ut2=can_upgrade_unittype(game.player_ptr,activeunits_type[sel]);
+	      ut2 = can_upgrade_unittype(game.player_ptr,
+				         activeunits_type[sel], TRUE);
 	      my_snprintf(buf, sizeof(buf),
 			  _("Upgrade as many %s to %s as possible for %d gold each?\n"
 			    "Treasury contains %d gold."),
@@ -649,7 +650,7 @@
     unit_type_iterate(i) {
       if ((unitarray[i].active_count > 0) || (unitarray[i].building_count > 0)) 
 {
-        can = (can_upgrade_unittype(game.player_ptr, i) != -1);
+        can = (can_upgrade_unittype(game.player_ptr, i, TRUE) != -1);
         my_snprintf(buf[0], sizeof(buf[0]), "%s", unit_name(i));
         my_snprintf(buf[1], sizeof(buf[1]), "%c", can ? '*': '-');
         my_snprintf(buf[2], sizeof(buf[2]), "%3d", unitarray[i].building_count);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-xaw/citydlg.c freeciv-patched/client/gui-xaw/citydlg.c
--- freeciv-cvs/client/gui-xaw/citydlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-xaw/citydlg.c	2003-06-30 12:16:42.000000000 +0100
@@ -1334,7 +1334,7 @@
     if (punit->homecity == pcity->id) {
       XtSetSensitive(XtNameToWidget(wd, "*button5"), FALSE);
     }
-    if (can_upgrade_unittype(game.player_ptr,punit->type) == -1) {
+    if (can_upgrade_unittype(game.player_ptr, punit->type, TRUE) == -1) {
       XtSetSensitive(XtNameToWidget(wd, "*button6"), FALSE);
     }
   }
@@ -2037,7 +2037,7 @@
     ut1 = punit->type;
     /* printf("upgrade_callback for %s\n", unit_types[ut1].name); */
 
-    ut2 = can_upgrade_unittype(game.player_ptr,ut1);
+    ut2 = can_upgrade_unittype(game.player_ptr, ut1, TRUE);
 
     if ( ut2 == -1 ) {
       /* this shouldn't generally happen, but it is conceivable */
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-xaw/gotodlg.c freeciv-patched/client/gui-xaw/gotodlg.c
--- freeciv-cvs/client/gui-xaw/gotodlg.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-xaw/gotodlg.c	2003-06-30 12:16:19.000000000 +0100
@@ -223,7 +223,7 @@
     city_list_iterate(game.players[i].cities, pcity) {
       char name[MAX_LEN_NAME+3];
       sz_strlcpy(name, pcity->name);
-      if (pcity->improvements[B_AIRPORT] == I_ACTIVE)
+      if (pcity->airlift)
 	sz_strlcat(name, "(A)");
       city_name_ptrs[j++]=mystrdup(name);
     }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/gui-xaw/repodlgs.c freeciv-patched/client/gui-xaw/repodlgs.c
--- freeciv-cvs/client/gui-xaw/repodlgs.c	2003-06-30 12:18:27.000000000 +0100
+++ freeciv-patched/client/gui-xaw/repodlgs.c	2003-06-30 12:16:42.000000000 +0100
@@ -970,7 +970,8 @@
   may_upgrade =
     ((inx != XAW_LIST_NONE) &&
      (unit_type_exists (activeunits_type[inx])) &&
-     (can_upgrade_unittype (game.player_ptr, activeunits_type[inx]) != -1));
+     (can_upgrade_unittype (game.player_ptr,
+			    activeunits_type[inx], TRUE) != -1));
 
   XtSetSensitive (upgrade_command, may_upgrade);
 }
@@ -1015,7 +1016,7 @@
     /* puts(unit_types[ut1].name); */
 
     ut2 = can_upgrade_unittype(game.player_ptr,
-			       activeunits_type[ret->list_index]);
+			       activeunits_type[ret->list_index], TRUE);
 
     my_snprintf(buf, sizeof(buf),
 	    _("Upgrade as many %s to %s as possible for %d gold each?\n"
@@ -1110,7 +1111,7 @@
 	   sizeof(activeunits_list_names[k]),
 	   "%-27s%c%9d%9d%9d%9d",
 	   unit_name(i),
-	   can_upgrade_unittype(game.player_ptr, i) != -1 ? '*': '-',
+	   can_upgrade_unittype(game.player_ptr, i, TRUE) != -1 ? '*': '-',
 	   unitarray[i].building_count,
 	   unitarray[i].active_count,
 	   unitarray[i].upkeep_shield,
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/helpdata.c freeciv-patched/client/helpdata.c
--- freeciv-cvs/client/helpdata.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/client/helpdata.c	2003-06-30 12:17:33.000000000 +0100
@@ -504,40 +504,16 @@
   
   assert(buf&&user_text);
   buf[0] = '\0';
-  if(which==B_AQUEDUCT) {
-    sprintf(buf+strlen(buf), _("Allows a city to grow larger than size %d.  "),
-	    game.aqueduct_size);
-    if(improvement_exists(B_SEWER)) {
-      char *s = improvement_types[B_SEWER].name;
-      sprintf(buf+strlen(buf),
-	      _("(The %s improvement is also required for a city to grow"
-		" larger than size %d.)  "), s, game.sewer_size);
-    }
-    strcat(buf,"\n");
-  }
-  if(which==B_SEWER) {
-    sprintf(buf+strlen(buf), _("Allows a city to grow larger than size %d.  "),
-	   game.sewer_size);
-  }
   if (imp->helptext) {
     sprintf(buf+strlen(buf), "%s  ", _(imp->helptext));
   }
-  if(which==B_BARRACKS
-     && tech_exists(improvement_types[B_BARRACKS].obsolete_by)
-     && tech_exists(improvement_types[B_BARRACKS2].obsolete_by)) {
-    sprintf(buf+strlen(buf),
-	   _("\n\nNote that discovering %s or %s will obsolete"
-	   " any existing %s.  "),
-	   advances[improvement_types[B_BARRACKS].obsolete_by].name,
-	   advances[improvement_types[B_BARRACKS2].obsolete_by].name,
-	   improvement_types[B_BARRACKS].name);
-  }
-  if(which==B_BARRACKS2
-     && tech_exists(improvement_types[B_BARRACKS2].obsolete_by)) {
+  if (improvement_types[which].obsolete_by != A_NONE &&
+      tech_exists(improvement_types[which].obsolete_by)) {
     sprintf(buf+strlen(buf),
-	   _("\n\nThe discovery of %s will make %s obsolete.  "),
-	   advances[improvement_types[B_BARRACKS2].obsolete_by].name,
-	   improvement_types[B_BARRACKS2].name);
+            _("\n\nNote that discovering %s will obsolete"
+            " any existing %s.  "),
+            advances[improvement_types[which].obsolete_by].name,
+            improvement_types[which].name);
   }
   if (strcmp(user_text, "")!=0) {
     sprintf(buf+strlen(buf), "\n\n%s", user_text);
@@ -555,16 +531,6 @@
   
   assert(buf&&user_text);
   buf[0] = '\0';
-  if(which==B_MANHATTEN && num_role_units(F_NUCLEAR)>0) {
-    int u, t;
-    u = get_role_unit(F_NUCLEAR, 0);
-    assert(u<game.num_unit_types);
-    t = get_unit_type(u)->tech_requirement;
-    assert(t<game.num_tech_types);
-    sprintf(buf+strlen(buf),
-	   _("Allows all players with knowledge of %s to build %s units.  "),
-	   advances[t].name, get_unit_type(u)->name);
-  }
   if (imp->helptext) {
     sprintf(buf+strlen(buf), "%s  ", _(imp->helptext));
   }
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/client/packhand.c freeciv-patched/client/packhand.c
--- freeciv-cvs/client/packhand.c	2003-06-30 12:18:28.000000000 +0100
+++ freeciv-patched/client/packhand.c	2003-06-30 12:18:03.000000000 +0100
@@ -75,6 +75,16 @@
 static int *reports_thaw_requests = NULL;
 static int reports_thaw_requests_size = 0;
 
+/* Keeps track of whether we are in a turn update or not. This is used by
+ * the city packet handling routines to decide whether to update improvement
+ * effects immediately on receiving new improvements, or to defer the update
+ * until the start of the turn. */
+static enum {
+  EU_BEFORE_YEAR,
+  EU_UPDATE_DEFERRED,
+  EU_WITHIN_YEAR
+} effect_update_state = EU_BEFORE_YEAR;
+
 /**************************************************************************
 ...
 **************************************************************************/
@@ -109,6 +119,9 @@
   char msg[MAX_LEN_MSG];
   char *s_capability = aconnection.capability;
 
+  /* Defer all effect updates until the start of the first year */
+  effect_update_state = EU_BEFORE_YEAR;
+
   sz_strlcpy(aconnection.capability, packet->capability);
 
   if (packet->you_can_login) {
@@ -244,7 +257,7 @@
       *impr_changed = TRUE;
     }
   } else if (!have_impr && pcity->improvements[impr] != I_NONE) {
-    city_remove_improvement(pcity, impr);
+    city_remove_improvement(pcity, impr, FALSE);
 
     if (impr_changed) {
       *impr_changed = TRUE;
@@ -258,15 +271,33 @@
 static void try_update_effects(bool need_update)
 {
   if (need_update) {
-    /* nothing yet... */
+    if (effect_update_state == EU_WITHIN_YEAR) {
+      update_all_effects();
+    } else {
+      effect_update_state = EU_UPDATE_DEFERRED;
+    }
   }
 }
 
 /**************************************************************************
+  If any effect updates were deferred by try_update_effects(), update them
+**************************************************************************/
+static void do_deferred_effect_updates(void)
+{
+  if (effect_update_state == EU_UPDATE_DEFERRED) {
+    update_all_effects();
+  }
+  effect_update_state = EU_WITHIN_YEAR;
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 void handle_game_state(struct packet_generic_integer *packet)
 {
+  /* If any effect updates were deferred, update effects now */
+  do_deferred_effect_updates();
+
   if (get_client_state() == CLIENT_SELECT_RACE_STATE
       && packet->value == CLIENT_GAME_RUNNING_STATE
       && game.player_ptr->nation == NO_NATION_SELECTED) {
@@ -377,6 +408,9 @@
     pcity->trade[i]=packet->trade[i];
     pcity->trade_value[i]=packet->trade_value[i];
   }
+
+  pcity->buildflags = packet->buildflags;
+  pcity->upkeep_free = packet->upkeep_free;
   
   pcity->food_prod=packet->food_prod;
   pcity->food_surplus=packet->food_surplus;
@@ -403,6 +437,9 @@
     /* Initialise list of improvements with city/building wide equiv_range. */
     improvement_status_init(pcity->improvements,
 			    ARRAY_SIZE(pcity->improvements));
+
+    /* Initialise city's vector of improvement effects. */
+    ceff_vector_init(&pcity->effects);
   }
   copy_worklist(&pcity->worklist, &packet->worklist);
   pcity->did_buy=packet->did_buy;
@@ -418,6 +455,10 @@
   pcity->disbanded_shields=packet->disbanded_shields;
   pcity->caravan_shields=packet->caravan_shields;
 
+  if (city_is_new) {
+    update_city_bonuses(pcity);
+  }
+
   i=0;
   for(y=0; y<CITY_MAP_SIZE; y++) {
     for(x=0; x<CITY_MAP_SIZE; x++) {
@@ -450,6 +491,8 @@
            pcity->owner==game.player_idx && popup_new_cities) 
           || packet->diplomat_investigate;
 
+  try_update_effects(need_effect_update);
+
   if (city_is_new && !city_has_changed_owner) {
     agents_city_new(pcity);
   } else {
@@ -457,8 +500,6 @@
   }
 
   handle_city_packet_common(pcity, city_is_new, popup, packet->diplomat_investigate);
-
-  try_update_effects(need_effect_update);
 }
 
 /**************************************************************************
@@ -593,6 +634,9 @@
     /* Initialise list of improvements with city/building wide equiv_range. */
     improvement_status_init(pcity->improvements,
 			    ARRAY_SIZE(pcity->improvements));
+
+    /* Initialise city's vector of improvement effects. */
+    ceff_vector_init(&pcity->effects);
   }
 
   update_improvement_from_packet(pcity, B_PALACE, packet->capital,
@@ -638,11 +682,17 @@
     pcity->did_sell           = FALSE;
     pcity->was_happy          = FALSE;
 
+    if (city_is_new) {
+      update_city_bonuses(pcity);
+    }
+
     for(y=0; y<CITY_MAP_SIZE; y++)
       for(x=0; x<CITY_MAP_SIZE; x++)
 	pcity->city_map[x][y] = C_TILE_EMPTY;
   } /* Dumb values */
 
+  try_update_effects(need_effect_update);
+
   if (city_is_new && !city_has_changed_owner) {
     agents_city_new(pcity);
   } else {
@@ -655,8 +705,6 @@
   if (update_descriptions && tile_visible_mapcanvas(pcity->x,pcity->y)) {
     update_city_descriptions();
   }
-
-  try_update_effects(need_effect_update);
 }
 
 /**************************************************************************
@@ -664,6 +712,9 @@
 **************************************************************************/
 void handle_new_year(struct packet_new_year *ppacket)
 {
+  /* If any effect updates were deferred, update effects now */
+  do_deferred_effect_updates();
+
   game.year = ppacket->year;
   /*
    * The turn was increased in handle_before_new_year()
@@ -702,6 +753,9 @@
 **************************************************************************/
 void handle_before_new_year(void)
 {
+  /* Defer all effect updates until the start of the year */
+  effect_update_state = EU_BEFORE_YEAR;
+
   clear_notify_window();
   /*
    * The local idea of the game turn is increased here since the
@@ -720,6 +774,9 @@
 **************************************************************************/
 void handle_start_turn(void)
 {
+  /* If any effect updates were deferred, update effects now */
+  do_deferred_effect_updates();
+
   agents_start_turn();
   non_ai_unit_focus = FALSE;
 
@@ -1113,6 +1170,43 @@
 /**************************************************************************
 ...
 **************************************************************************/
+static bool update_wonder(Impr_Type_id impr, int cityid, int plrno)
+{
+  struct player *pplayer;
+  bool retval = FALSE;
+
+  if (!is_wonder(impr))
+    return FALSE;
+
+  if (plrno == -1) {
+    pplayer = NULL;
+  } else {
+    pplayer = &game.players[plrno];
+  }
+
+  /* Newly destroyed wonder */
+  if (cityid == -1 && game.global_wonders[impr] >= 0) {
+    add_destroyed_improvement(pplayer, impr);
+    retval = TRUE;
+  }
+
+  if (cityid >= 0 && improvement_types[impr].equiv_range == EFR_WORLD) {
+    if (cityid == -1 && game.improvements[impr] != I_NONE) {
+      game.improvements[impr] = I_NONE;
+      retval = TRUE;
+    } else if (cityid >= 0 && game.improvements[impr] == I_NONE) {
+      game.improvements[impr] = I_ACTIVE;
+      retval = TRUE;
+    }
+  }
+  game.global_wonders[impr] = cityid;
+  game.destroyed_owner[impr] = pplayer;
+  return retval;
+}
+
+/**************************************************************************
+...
+**************************************************************************/
 void handle_game_info(struct packet_game_info *pinfo)
 {
   int i;
@@ -1135,29 +1229,35 @@
   game.nuclearwinter=pinfo->nuclearwinter;
   game.cooling=pinfo->cooling;
   if (!can_client_change_view()) {
+    /* Nasty kludge to let old code which assumes B_PALACE and B_CITY work */
+    B_PALACE = get_improvement_for_effect(NULL, EFT_CAPITAL_CITY, NULL);
+    if (B_PALACE == B_LAST) {
+      freelog(LOG_ERROR, "Cannot find any capital city improvement");
+      exit(EXIT_FAILURE);
+    }
+
+    B_CITY = get_improvement_for_effect(NULL, EFT_UNIT_DEFEND, NULL);
+    if (B_CITY == B_LAST) {
+      freelog(LOG_ERROR, "Cannot find any city walls improvement");
+      exit(EXIT_FAILURE);
+    }
+
     improvement_status_init(game.improvements,
 			    ARRAY_SIZE(game.improvements));
 
+    /* Free vector of effects with a worldwide range. */
+    geff_vector_free(&game.effects);
+    /* Free vector of destroyed effects. */
+    ceff_vector_free(&game.destroyed_effects);
+
     game.player_idx = pinfo->player_idx;
     game.player_ptr = &game.players[game.player_idx];
   }
   for(i=0; i<A_LAST/*game.num_tech_types*/; i++)
     game.global_advances[i]=pinfo->global_advances[i];
   for(i=0; i<B_LAST/*game.num_impr_types*/; i++) {
-     game.global_wonders[i]=pinfo->global_wonders[i];
-/* Only add in the improvement if it's in a "foreign" (i.e. unknown) city
-   and has equiv_range==World - otherwise we deal with it in its home
-   city anyway */
-    if (is_wonder(i) && improvement_types[i].equiv_range==EFR_WORLD &&
-        !find_city_by_id(game.global_wonders[i])) {
-      if (game.global_wonders[i] <= 0 && game.improvements[i] != I_NONE) {
-        game.improvements[i] = I_NONE;
-        need_effect_update = TRUE;
-      } else if (game.global_wonders[i] > 0 && game.improvements[i] == I_NONE) {
-        game.improvements[i] = I_ACTIVE;
-        need_effect_update = TRUE;
-      }
-    }
+    need_effect_update |= update_wonder(i, pinfo->global_wonders[i],
+                                        pinfo->destroyed_owner[i]);
   }
 
   /* Only update effects if a new wonder appeared or was destroyed */
@@ -1291,9 +1391,14 @@
   bool poptechup, new_tech = FALSE;
   char msg[MAX_LEN_MSG];
   struct player *pplayer = &game.players[pinfo->playerno];
+  bool govnation_changed = FALSE;
 
   sz_strlcpy(pplayer->name, pinfo->name);
 
+  if (pplayer->nation != pinfo->nation
+      || pplayer->government != pinfo->government) {
+    govnation_changed = TRUE;
+  }
   pplayer->nation=pinfo->nation;
   pplayer->is_male=pinfo->is_male;
   pplayer->team = pinfo->team;
@@ -1307,6 +1412,14 @@
   pplayer->gives_shared_vision = pinfo->gives_shared_vision;
   pplayer->city_style=pinfo->city_style;
 
+  if (!pplayer->island_effects && map.num_continents > 0) {
+    pplayer->island_effects = fc_calloc(map.num_continents + 1,
+					sizeof(struct geff_vector));
+    for (i = 1; i <= map.num_continents; i++) {
+      geff_vector_init(&pplayer->island_effects[i]);
+    }
+  }
+
   for (i = 0; i < MAX_NUM_PLAYERS + MAX_NUM_BARBARIANS; i++) {
     pplayer->diplstates[i].type =
       pinfo->diplstates[i].type;
@@ -1374,6 +1487,11 @@
       append_output_window(msg);
     }
   }
+
+  if (govnation_changed) {
+    player_update_global_effects(pplayer);
+    update_all_effects();
+  }
   
   if (pplayer == game.player_ptr &&
       (pplayer->revolution < 1 || pplayer->revolution > 5) &&
@@ -1822,6 +1940,7 @@
   game.government_when_anarchy = packet->government_when_anarchy;
   game.default_government = packet->default_government;
 
+  game.num_unit_flags = packet->num_unit_flags;
   game.num_unit_types = packet->num_unit_types;
   game.num_impr_types = packet->num_impr_types;
   game.num_tech_types = packet->num_tech_types;
@@ -1885,6 +2004,7 @@
   u->paratroopers_range = p->paratroopers_range;
   u->paratroopers_mr_req = p->paratroopers_mr_req;
   u->paratroopers_mr_sub = p->paratroopers_mr_sub;
+  u->effect             = p->effect;  /* pointer assignment */
 
   u->helptext = p->helptext;	/* pointer assignment */
 
@@ -2056,7 +2176,7 @@
 		    b->effect[inx].aff_unit,
 		    (b->effect[inx].aff_unit == UCL_LAST) ?
 		    "All" :
-		    unit_class_name(b->effect[inx].aff_unit));
+		    unit_class_names[b->effect[inx].aff_unit]);
 	ptr = strchr(ptr, '\0');
 	my_snprintf(ptr, sizeof(buf)-(ptr-buf), " aff_terr=%d/%s",
 		    b->effect[inx].aff_terr,
@@ -2162,6 +2282,7 @@
   gov->ruler_titles = fc_calloc(gov->num_ruler_titles,
 				sizeof(struct ruler_title));
   
+  gov->effect   = p->effect;    /* pointer assignment */
   gov->helptext = p->helptext;	/* pointer assignment */
   
   tilespec_setup_government(p->id);
@@ -2297,6 +2418,7 @@
     pl->leaders[i].is_male = p->leader_sex[i];
   }
   pl->city_style = p->city_style;
+  pl->effect     = p->effect;  /* pointer assignment */
 
   if (p->class[0] != '\0') {
     pl->class = mystrdup(p->class);
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/aicore/pf_tools.c freeciv-patched/common/aicore/pf_tools.c
--- freeciv-cvs/common/aicore/pf_tools.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/aicore/pf_tools.c	2003-06-30 12:17:19.000000000 +0100
@@ -286,8 +286,7 @@
   parameter->zoc_used = (unit_type(punit)->move_type == LAND_MOVING
 			 && !unit_flag(punit, F_IGZOC));
 
-  if (unit_flag(punit, F_TRIREME)
-      && base_trireme_loss_pct(unit_owner(punit)) > 0) {
+  if (base_ship_loss_pct(punit, NULL) > 0) {
     parameter->turn_mode = TM_WORST_TIME;
     parameter->is_pos_dangerous = trireme_is_pos_dangerous;
   } else {
@@ -325,8 +324,7 @@
 
   parameter->zoc_used = FALSE;
 
-  if (unit_flag(punit, F_TRIREME)
-      && base_trireme_loss_pct(unit_owner(punit)) > 0) {
+  if (base_ship_loss_pct(punit, NULL) > 0) {
     parameter->is_pos_dangerous = trireme_is_pos_dangerous;
   } else {
     parameter->is_pos_dangerous = NULL;
diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/capstr.c freeciv-patched/common/capstr.c
--- freeciv-cvs/common/capstr.c	2003-06-30 12:18:26.000000000 +0100
+++ freeciv-patched/common/capstr.c	2003-06-30 12:16:49.000000000 +0100
@@ -78,7 +78,7 @@
                    "city_struct_minor_cleanup obsolete_last class_legend " \
                    "+impr_req +waste +fastfocus +continent +small_dipl " \
                    "+no_nation_selected +diplomacy +no_extra_tiles " \
-                   "+diplomacy2 +citizens_style +root_tech"
+                   "+diplomacy2 +citizens_style +root_tech impr_gen"
 
 /* "+1.14.0" is protocol for 1.14.0 release.
  *
